/*
 * ipfind.c: (C) TOYODA Eizi, 1995
 * author: toyoda@ori.u-tokyo.ac.jp
 */

#include <stdio.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

	int
ipfind(oldname)
	char		*oldname;
{
	struct hostent	*hostinfo;
	unsigned char	*ipaddr;
	unsigned int	ipa[4];
	if (sscanf(oldname, "%u.%u.%u.%u", ipa, ipa+1, ipa+2, ipa+3) == 4) {
		ipaddr = (unsigned char *)"....";
		ipaddr[0] = ipa[0];
		ipaddr[1] = ipa[1];
		ipaddr[2] = ipa[2];
		ipaddr[3] = ipa[3];
		hostinfo = gethostbyaddr(ipaddr, 4, AF_INET);
		if (hostinfo == NULL) {
			fprintf(stderr, "host %s unknown\n", oldname);
			return 1;
		}
		fprintf(stdout, "%s\n", hostinfo->h_name);
	} else {
		hostinfo = gethostbyname(oldname);
		if (hostinfo == NULL) {
			fprintf(stderr, "host %s unknown\n", oldname);
			return 1;
		}
		ipaddr = (unsigned char *)(hostinfo->h_addr);
		fprintf(stdout, "%u.%u.%u.%u\n",
			ipaddr[0], ipaddr[1], ipaddr[2], ipaddr[3]);
	}
	return 0;
}

	int
main(argc, argv)
	int		argc;
	char		*argv[];
{
	int		r, i;
	if (argc < 2) {
		fprintf(stderr, "usage: %s hostname\n", argv[0]);
		return -1;
	}
	for (i=1; i<argc; i++) {
		if ((r = ipfind(argv[i])) != 0)
			break;
	}
	return r;
}
